<?php

namespace Automata\Storage;

use Automata\Tool;
use InvalidArgumentException;

class ToolMemory
{
	/** @var Tool[] */
	private array $memory = [];


	public function save(Tool $tool): void
	{
		$this->guardInvalidToolNumber($tool->T);
		$this->memory[$tool->T] = $tool;
	}


	public function read(int $T): ?Tool
	{
		return @$this->memory[$T];
	}


	private function guardInvalidToolNumber(int $T): void
	{
		if ($T < 1 || $T > 64) {
			throw new InvalidArgumentException('Tool number must be in range 1 - 64');
		}
	}

}
